.include "nes.h"
.include "ram.h"

.segment "BSS"
cursor_x: .res 1
cursor_y: .res 1
cursor_x_target: .res 1
cursor_y_target: .res 1
cursor_dtimer: .res 1

.segment "CODE"

.proc draw_main_cursor
  ldx oam_used
  lda cursor_y
  cmp #240
  bcs nodraw
  sbc #0
  sta OAM+0,x
  clc
  adc #8
  sta OAM+4,x
  lda cursor_x
  sec
  sbc #2
  sta OAM+3,x
  sta OAM+7,x
  lda #1
  sta OAM+5,x
  lda #0
  sta OAM+1,x
  sta OAM+2,x
  sta OAM+6,x
  txa
  clc
  adc #8
  sta oam_used
nodraw:
  rts
.endproc

KEY_ALLDIRS = KEY_RIGHT|KEY_LEFT|KEY_UP|KEY_DOWN
.proc move_main_cursor
ar_keys = 0

  ; If no keys are being held, reset the autorepeat timer
  lda cur_keys+0
  and #KEY_ALLDIRS
  bne dpad_move
  lda #12
  sta cursor_dtimer
  bne noUp
dpad_move:

  ; Use whatever key was newly pressed, or use all held directions
  ; if the autorepeat timer has ticked
  lda new_keys+0
  dec cursor_dtimer
  bpl :+
  ldy #1
  sty cursor_dtimer
  ora cur_keys+0
:
  and #KEY_ALLDIRS

  ; For each key, move in the appropriate direction
  lsr a
  sta ar_keys
  bcc noRight
  lda cursor_x_target
  and #$F8
  adc #8+3  ; 4 for center of 8x8 cell, minus 1 for carry being set
  cmp #240
  bcs noRight
  sta cursor_x_target
noRight:

  lsr ar_keys
  bcc noLeft
  lda cursor_x_target
  and #$F8
  adc #(<-8)+3
  cmp #16
  bcc noLeft
  sta cursor_x_target
noLeft:

  lsr ar_keys
  bcc noDown
  lda cursor_y_target
  and #$F8
  adc #8+3
  cmp #224
  bcs noUp
  sta cursor_y_target
noDown:

  lsr ar_keys
  bcc noUp
  lda cursor_y_target
  and #$F8
  adc #(<-8)+3
  cmp #16
  bcc noUp
  sta cursor_y_target
noUp:

  ldx #1
approachloop:
  lda cursor_x_target,x
  sec
  sbc cursor_x,x
  beq noxmove
  ; Round away from 0
  bcc :+
  sbc #1
:
  ror a
  lsr a
  cmp #$40
  sbc #$3F
  clc
  adc cursor_x,x
  sta cursor_x,x
noxmove:
  dex
  bpl approachloop

  ; Now handle mice
  ldx #1
mouseloop:
  lda cur_keys+2,x
  and #$0F
  cmp #1
  bne not_a_mouse
  
  lda cur_keys+4,x
  and #$7F
  beq mouseNoMoveY
  lda cur_keys+4,x
  bmi mouseGoUp
  clc
  adc cursor_y_target
  bcs mouseDown2far
  cmp #223
  bcc mouseHaveY
mouseDown2far:
  lda #223
  bne mouseHaveY
mouseGoUp:
  sec
  eor #$7F
  adc cursor_y_target
  bcc mouseUp2far
  cmp #16
  bcs mouseHaveY
mouseUp2far:
  lda #16
mouseHaveY:
  sta cursor_y
  sta cursor_y_target
mouseNoMoveY:

  lda cur_keys+6,x
  and #$7F
  beq mouseNoMoveX
  lda cur_keys+6,x
  bmi mouseGoLeft
  clc
  adc cursor_x_target
  bcs mouseRight2far
  cmp #239
  bcc mouseHaveX
mouseRight2far:
  lda #239
  bne mouseHaveX
mouseGoLeft:
  sec
  eor #$7F
  adc cursor_x_target
  bcc mouseLeft2far
  cmp #16
  bcs mouseHaveX
mouseLeft2far:
  lda #16
mouseHaveX:
  sta cursor_x_target
  sta cursor_x
mouseNoMoveX:

not_a_mouse:
  dex
  bpl mouseloop
  rts
.endproc
