.ifndef RAM_H
.define RAM_H

.macro lday arg
  .local argvalue
  .if (.match (.left (1, {arg}), #))
    argvalue = .right(.tcount({arg})-1, {arg})
    lda #>argvalue
    ldy #<argvalue
  .else
    argvalue = arg
    lda arg+1
    ldy arg
  .endif
.endmacro

.global OAM
.globalzp oam_used, nmis

; ppuclear.s
.global ppu_clear_oam, ppu_clear_nt, ppu_screen_on

; unpb53.s
.global unpb53_some, PB53_outbuf, load_pb53_blk
.globalzp ciSrc, ciDst, ciBufStart, ciBufEnd

; pads.s
.global read_pads, change_mouse_speed
.globalzp cur_keys, new_keys, joyportmasks

; title.s
.global draw_recttileregion

; vwf_draw.s
.global vwfPutTile, vwfPuts, vwfPuts0
.global vwfGlyphWidth, vwfStrWidth, vwfStrWidth0
.global clearLineImg, copyLineImg, lineImgBuf, invertTiles

;ticker.s
; http://www.cc65.org/doc/ca65-15.html
.struct Ticker
  popup_text       .byte 48   ; buffer in which to format a popup
  hl_rot           .byte 32   ; Last headline for each headline category
  pop_queue_msg    .byte 16   ; Popups (save, unlock, win) waiting to be displayed
  pop_queue_arg    .byte 16   ; Argument (upgrade number, achievement number) for pop_queue
  last_tile        .byte 8    ; 1-bit tile containing right half of last glyph
  last_srcaddr     .byte 2    ; Byte position at which to restart drawing
  last_x           .byte 1    ; Pixel at which X drawing was interrupted by overflow
  timeleft         .byte 1    ; Number of tenths of seconds before going to the queue
  last_hl          .byte 1    ; Headline to redisplay ($FF for none)
.endstruct
.global ticker
.global write_copr_notice

; con.s
.global con_puts
.globalzp con_demo  ; long call

; bcd.s
.global bcd8bit

; cookiecount.s
.global cookies, cookiesEarned, cookiesPerSecond, cookiesPerClick
.global earn_reg_b, spend_reg_b, dissolve_reg_b
.global earn_click, earn_second, build_topbarbuf
.global topbarbuf_line1, topbarbuf_line2, topbarbuf_label

; cursorcontrol.s
.global draw_main_cursor, move_main_cursor
.global cursor_x, cursor_y, cursor_x_target, cursor_y_target

; vblank.s
.global init_bgup, oam_ready, nmi, last_PPUCTRL, last_PPUMASK
.global prep_copyLineImg, prep_erase_wordmark, prep_copy_topbarbuf
.global bgup_args

; inter-bank procedure calls
.global bankcall, bankrts
.globalzp do_title_screen, setup_big_cookie, do_big_cookie, con_demo
.macro jsl callnumber
  ldx #callnumber
  jsr bankcall
.endmacro
.macro rtl
  jmp bankrts
.endmacro

.endif
