.include "nes.h"
.include "ram.h"

.segment "BSS"

; http://www.cc65.org/doc/ca65-15.html
; access as ticker+Ticker::hl_rot, etc.
ticker: .tag Ticker

time_subtenths:.res 1
time_tenths:   .res 1

TCKST_HL_TL = 0
TCKST_HL_TRBL = 1
TCKST_HL_BR = 2
TCKST_HL_IDLE = 3   ; idle
TCKST_POP_TL = 4
TCKST_POP_TR = 5
TCKST_POP_BL = 6
TCKST_POP_BR = 7

.segment "CODE"
.proc write_copr_notice
  lda #0
  sta ticker+Ticker::last_hl
.endproc
.proc setup_headline
  lda #<hltable
  sta 0
  lda #>hltable
  sta 1
  lda ticker+Ticker::last_hl
  asl a
  tay
  bcc :+
  inc 1
:
  lda (0),y
  sta ticker+Ticker::last_srcaddr
  iny
  lda (0),y
  sta ticker+Ticker::last_srcaddr+1
  jsr tickerstep1
  jsr tickerstep2
  jsr tickerstep3
  rts
.endproc

.proc tickerstep1
  jsr clr0to135
  lda ticker+Ticker::last_srcaddr+1
  ldy ticker+Ticker::last_srcaddr
  jsr vwfStrWidth
  lsr a
  eor #$FF
  adc #97
  tax
  jsr vwfPuts0
  stx ticker+Ticker::last_x
  lda 1
  sta ticker+Ticker::last_srcaddr+1
  lda 0
  sta ticker+Ticker::last_srcaddr
  jsr savetile16
  ; Transfer first line
  lda #$0D
  ldy #$08
  jmp copyLineImg
.endproc

.proc finish_previous_line
  jsr restoretile0
  jsr clr8to135
  lda ticker+Ticker::last_x
  eor #$80
  bpl :+
  lda #0
:
  tax
  lda ticker+Ticker::last_srcaddr+1
  ldy ticker+Ticker::last_srcaddr
  jmp vwfPuts
.endproc

.proc tickerstep2
  ; 2. Write rest of first line
  jsr finish_previous_line

  ; At this point, AAYY points to the second line or to a NUL.
  ; Measure and write second line
  jsr vwfStrWidth
  lsr a
  eor #$FF
  adc #161
  bmi :+
  tax
  jsr vwfPuts0
:
  stx ticker+Ticker::last_x
  lda 1
  sta ticker+Ticker::last_srcaddr+1
  lda 0
  sta ticker+Ticker::last_srcaddr
  jsr savetile16
  ; Transfer end of first line and start of second line
  lda #$0E
  ldy #$08
  jmp copyLineImg
.endproc

.proc tickerstep3
  jsr finish_previous_line
  lda #$0F
  ldy #$08
  jmp copyLineImg
.endproc

.proc savetile16
  ldx #7
loop:
  lda lineImgBuf+128,x
  sta ticker+Ticker::last_tile,x
  dex
  bpl loop
  rts
.endproc

.proc restoretile0
  ldx #7
loop:
  lda ticker+Ticker::last_tile,x
  sta lineImgBuf+0,x
  dex
  bpl loop
  rts
.endproc

.proc clr0to135
  ldx #7
  lda #0
clrloop:
  sta lineImgBuf,x
  dex
  bpl clrloop
.endproc
.proc clr8to135
  ldx #0
  txa
clrloop:
  sta lineImgBuf+8,x
  inx
  bpl clrloop
  rts
.endproc

.proc update_game_time
  inc time_subtenths
  lda time_subtenths
  cmp #6
  bcc time_ok
  lda #0
  sta time_subtenths
  inc time_tenths
  lda time_tenths
  cmp #10
  bcc time_ok
  lda #0
  sta time_tenths

time_ok:
  rts
.endproc


;.segment "BANK05"
hltable:
  .addr hl_coprnotice, hl_ssocd
hl_coprnotice:
  .byte $81," 2014 Orteil & D. Yerrick",10
  .byte "Click the cookie to start this shit",0
hl_ssocd:
  .byte "News: nurses report ",34,"strange scent of",10
  .byte "dough",34," around female elderly patients!",0


